/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2210 from the
 * contents of Interrupt.xs. Do not edit this file, edit Interrupt.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

/* Autogenerated XS functions are static. */
#define XSUBPP_STATIC_XS

#line 1 "Interrupt.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "schmorp.h"

typedef volatile sig_atomic_t atomic_t;

static int *sig_pending, *psig_pend; /* make local copies because of missing THX */
static Sighandler_t old_sighandler;
static atomic_t async_pending;

#define PERL_VERSION_ATLEAST(a,b,c)                             \
  (PERL_REVISION > (a)                                          \
   || (PERL_REVISION == (a)                                     \
       && (PERL_VERSION > (b)                                   \
           || (PERL_VERSION == (b) && PERL_SUBVERSION >= (c)))))

#if defined(HAS_SIGACTION) && defined(SA_SIGINFO)
# define HAS_SA_SIGINFO 1
#endif

#if !PERL_VERSION_ATLEAST(5,10,0)
# undef HAS_SA_SIGINFO
#endif

/*****************************************************************************/

typedef struct {
  SV *cb;
  void (*c_cb)(pTHX_ void *c_arg, int value);
  void *c_arg;
  SV *fh_r, *fh_w;
  SV *value;
  int signum;
  int autodrain;
  ANY *scope_savestack;
  volatile int blocked;

  s_epipe ep;
  int fd_wlen;
  atomic_t fd_enable;
  atomic_t pending;
  volatile IV *valuep;
  atomic_t hysteresis;
} async_t;

static AV *asyncs;
static async_t *sig_async [SIG_SIZE];

#define SvASYNC_nrv(sv) INT2PTR (async_t *, SvIVX (sv))
#define SvASYNC(rv)     SvASYNC_nrv (SvRV (rv))

static void async_signal (void *signal_arg, int value);

static void
setsig (int signum, void (*handler)(int))
{
#if _WIN32
  signal (signum, handler);
#else
  struct sigaction sa;
  sa.sa_handler = handler;
  sigfillset (&sa.sa_mask);
  sa.sa_flags = 0; /* if we interrupt a syscall, we might drain the pipe before it became ready */
  sigaction (signum, &sa, 0);
#endif
}

static void
async_sigsend (int signum)
{
  async_signal (sig_async [signum], 0);
}

/* the main workhorse to signal */
static void
async_signal (void *signal_arg, int value)
{
  static char pipedata [8];

  async_t *async = (async_t *)signal_arg;
  int pending = async->pending;

  if (async->hysteresis)
    setsig (async->signum, SIG_IGN);

  *async->valuep = value ? value : 1;
  async->pending = 1;
  async_pending  = 1;
  psig_pend [9]  = 1;
  *sig_pending   = 1;

  if (!pending && async->fd_enable && async->ep.len)
    s_epipe_signal (&async->ep);
}

static void
handle_async (async_t *async)
{
  int old_errno = errno;
  int value = *async->valuep;

  *async->valuep = 0;
  async->pending = 0;

  /* restore signal */
  if (async->hysteresis)
    setsig (async->signum, async_sigsend);

  /* drain pipe */
  if (async->fd_enable && async->ep.len && async->autodrain)
    s_epipe_drain (&async->ep);

  if (async->c_cb)
    {
      dTHX;
      async->c_cb (aTHX_ async->c_arg, value);
    }

  if (async->cb)
    {
      dSP;

      SV *saveerr = SvOK (ERRSV) ? sv_mortalcopy (ERRSV) : 0;
      SV *savedie = PL_diehook;

      PL_diehook = 0;

      PUSHSTACKi (PERLSI_SIGNAL);

      PUSHMARK (SP);
      XPUSHs (sv_2mortal (newSViv (value)));
      PUTBACK;
      call_sv (async->cb, G_VOID | G_DISCARD | G_EVAL);

      if (SvTRUE (ERRSV))
        {
          SPAGAIN;

          PUSHMARK (SP);
          PUTBACK;
          call_sv (get_sv ("Async::Interrupt::DIED", 1), G_VOID | G_DISCARD | G_EVAL | G_KEEPERR);

          sv_setpvn (ERRSV, "", 0);
        }

      if (saveerr)
        sv_setsv (ERRSV, saveerr);

      {
        SV *oldhook = PL_diehook;
        PL_diehook = savedie;
        SvREFCNT_dec (oldhook);
      }

      POPSTACK;
    }

  errno = old_errno;
}

static void
handle_asyncs (void)
{
  int i;

  async_pending = 0;

  for (i = AvFILLp (asyncs); i >= 0; --i)
    {
      SV *async_sv = AvARRAY (asyncs)[i];
      async_t *async = SvASYNC_nrv (async_sv);

      if (async->pending && !async->blocked)
        {
          /* temporarily keep a refcount */
          SvREFCNT_inc (async_sv);
          handle_async (async);
          SvREFCNT_dec (async_sv);

          /* the handler could have deleted any number of asyncs */
          if (i > AvFILLp (asyncs))
            i = AvFILLp (asyncs);
        }
    }
}

#if HAS_SA_SIGINFO
static Signal_t async_sighandler (int signum, siginfo_t *si, void *sarg)
{
  if (signum == 9)
    handle_asyncs ();
  else
    old_sighandler (signum, si, sarg);
}
#else
static Signal_t async_sighandler (int signum)
{
  if (signum == 9)
    handle_asyncs ();
  else
    old_sighandler (signum);
}
#endif

#define block(async) ++(async)->blocked

static void
unblock (async_t *async)
{
  --async->blocked;
  if (async->pending && !async->blocked)
    handle_async (async);
}

static void
scope_block_cb (pTHX_ void *async_sv)
{
  async_t *async = SvASYNC_nrv ((SV *)async_sv);

  async->scope_savestack = 0;
  unblock (async);
  SvREFCNT_dec (async_sv);
}

static void
scope_block (SV *async_sv)
{
  async_t *async = SvASYNC_nrv (async_sv);

  /* as a heuristic, we skip the scope block if we already are blocked */
  /* and the existing scope block used the same savestack */

  if (!async->scope_savestack || async->scope_savestack != PL_savestack)
    {
      async->scope_savestack = PL_savestack;
      block (async);

      LEAVE; /* unfortunately, perl sandwiches XS calls into ENTER/LEAVE */
      SAVEDESTRUCTOR_X (scope_block_cb, (void *)SvREFCNT_inc (async_sv));
      ENTER; /* unfortunately, perl sandwiches XS calls into ENTER/LEAVE */
    }
}

#line 259 "Interrupt.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 311 "Interrupt.c"
static
XS(XS_Async__Interrupt__alloc)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 7)
       croak_xs_usage(cv,  "cb, c_cb, c_arg, fh_r, fh_w, signl, pvalue");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	cb = ST(0);
	void *	c_cb = INT2PTR(void *,SvIV(ST(1)));
	void *	c_arg = INT2PTR(void *,SvIV(ST(2)));
	SV *	fh_r = ST(3);
	SV *	fh_w = ST(4);
	SV *	signl = ST(5);
	SV *	pvalue = ST(6);
#line 261 "Interrupt.xs"
{
        SV *cv   = SvOK (cb) ? SvREFCNT_inc (s_get_cv_croak (cb)) : 0;
  	async_t *async;

        Newz (0, async, 1, async_t);

        XPUSHs (sv_2mortal (newSViv (PTR2IV (async))));
        /* TODO: need to bless right now to ensure deallocation */
        av_push (asyncs, TOPs);

        SvGETMAGIC (fh_r); SvGETMAGIC (fh_w);
        if (SvOK (fh_r) || SvOK (fh_w))
          {
            int fd_r = s_fileno_croak (fh_r, 0);
            int fd_w = s_fileno_croak (fh_w, 1);

            async->fh_r      = newSVsv (fh_r);
            async->fh_w      = newSVsv (fh_w);
            async->ep.fd [0] = fd_r;
            async->ep.fd [1] = fd_w;
            async->ep.len    = 1;
            async->fd_enable = 1;
          }

        async->value     = SvROK (pvalue)
                           ? SvREFCNT_inc_NN (SvRV (pvalue))
                           : NEWSV (0, 0);

        sv_setiv (async->value, 0);
        SvIOK_only (async->value); /* just to be sure */
        SvREADONLY_on (async->value);

        async->valuep    = &(SvIVX (async->value));

        async->autodrain = 1;
        async->cb        = cv;
        async->c_cb      = c_cb;
        async->c_arg     = c_arg;
        async->signum    = SvOK (signl) ? s_signum_croak (signl) : 0;

        if (async->signum)
          {
            if (async->signum < 0)
              croak ("Async::Interrupt::new got passed illegal signal name or number: %s", SvPV_nolen (signl));

            sig_async [async->signum] = async;
            setsig (async->signum, async_sigsend);
          }
}
#line 382 "Interrupt.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_Async__Interrupt_signal_hysteresis)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "async, enable");
    {
	async_t *	async = SvASYNC (ST(0));
	int	enable = (int)SvIV(ST(1));
#line 314 "Interrupt.xs"
        async->hysteresis = enable;
#line 403 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}

static
XS(XS_Async__Interrupt_signal_func)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "async");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	async_t *	async = SvASYNC (ST(0));
#line 319 "Interrupt.xs"
        EXTEND (SP, 2);
        PUSHs (sv_2mortal (newSViv (PTR2IV (async_signal))));
        PUSHs (sv_2mortal (newSViv (PTR2IV (async))));
#line 426 "Interrupt.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_Async__Interrupt_scope_block_func)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0);
#line 326 "Interrupt.xs"
        EXTEND (SP, 2);
        PUSHs (sv_2mortal (newSViv (PTR2IV (scope_block))));
        PUSHs (sv_2mortal (newSViv (PTR2IV (SvRV (self)))));
#line 450 "Interrupt.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_Async__Interrupt_c_var)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "async");
    {
	IV	RETVAL;
	dXSTARG;
	async_t *	async = SvASYNC (ST(0));
#line 333 "Interrupt.xs"
        RETVAL = PTR2IV (async->valuep);
#line 472 "Interrupt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

static
XS(XS_Async__Interrupt_signal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "async, value= 1");
    {
	async_t *	async = SvASYNC (ST(0));
	int	value;

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 340 "Interrupt.xs"
        async_signal (async, value);
#line 499 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}

static
XS(XS_Async__Interrupt_block)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "async");
    {
	async_t *	async = SvASYNC (ST(0));
#line 345 "Interrupt.xs"
        block (async);
#line 518 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}

static
XS(XS_Async__Interrupt_unblock)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "async");
    {
	async_t *	async = SvASYNC (ST(0));
#line 350 "Interrupt.xs"
        unblock (async);
#line 537 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}

static
XS(XS_Async__Interrupt_scope_block)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0);
#line 355 "Interrupt.xs"
        scope_block (SvRV (self));
#line 556 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}

static
XS(XS_Async__Interrupt_pipe_enable)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "async");
    {
	async_t *	async = SvASYNC (ST(0));
#line 363 "Interrupt.xs"
        async->fd_enable = ix;
#line 576 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}

static
XS(XS_Async__Interrupt_pipe_fileno)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "async");
    {
	int	RETVAL;
	dXSTARG;
	async_t *	async = SvASYNC (ST(0));
#line 368 "Interrupt.xs"
        if (!async->ep.len)
          {
            int res;

            /*block (async);*//*TODO*/
            res = s_epipe_new (&async->ep);
            async->fd_enable = 1;
            /*unblock (async);*//*TODO*/

            if (res < 0)
              croak ("Async::Interrupt: unable to initialize event pipe");
          }

	RETVAL = async->ep.fd [0];
#line 610 "Interrupt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

static
XS(XS_Async__Interrupt_pipe_autodrain)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "async, enable= -1");
    {
	int	RETVAL;
	dXSTARG;
	async_t *	async = SvASYNC (ST(0));
	int	enable;

	if (items < 2)
	    enable = -1;
	else {
	    enable = (int)SvIV(ST(1));
	}
#line 388 "Interrupt.xs"
	RETVAL = async->autodrain;
        if (enable >= 0)
          async->autodrain = enable;
#line 641 "Interrupt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

static
XS(XS_Async__Interrupt_post_fork)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "async");
    {
	async_t *	async = SvASYNC (ST(0));
#line 397 "Interrupt.xs"
        if (async->ep.len)
          {
  	    int res;

            /*block (async);*//*TODO*/
            res = s_epipe_renew (&async->ep);
            /*unblock (async);*//*TODO*/

            if (res < 0)
              croak ("Async::Interrupt: unable to initialize event pipe after fork");
          }
#line 671 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}

static
XS(XS_Async__Interrupt_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0);
#line 412 "Interrupt.xs"
{
  	int i;
  	SV *async_sv = SvRV (self);
  	async_t *async = SvASYNC_nrv (async_sv);

        for (i = AvFILLp (asyncs); i >= 0; --i)
          if (AvARRAY (asyncs)[i] == async_sv)
            {
              AvARRAY (asyncs)[i] = AvARRAY (asyncs)[AvFILLp (asyncs)];
              av_pop (asyncs);
              goto found;
            }

        if (!PL_dirty)
          warn ("Async::Interrupt::DESTROY could not find async object in list of asyncs, please report");

	found:

        if (async->signum)
          setsig (async->signum, SIG_DFL);

        if (!async->fh_r && async->ep.len)
          s_epipe_destroy (&async->ep);

        SvREFCNT_dec (async->fh_r);
        SvREFCNT_dec (async->fh_w);
        SvREFCNT_dec (async->cb);
        SvREFCNT_dec (async->value);

        Safefree (async);
}
#line 720 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}

static
XS(XS_Async__Interrupt_sig2num)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "signame_or_number");
    {
	SV *	RETVAL;
	SV *	signame_or_number = ST(0);
#line 451 "Interrupt.xs"
{
  	int signum = s_signum (signame_or_number);

        if (signum < 0)
          RETVAL = &PL_sv_undef;
        else if (ix)
          RETVAL = newSVpv (PL_sig_name [signum], 0);
        else
          RETVAL = newSViv (signum);
}
#line 750 "Interrupt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

static
XS(XS_Async__Interrupt__EventPipe_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "klass");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const char *	klass = (const char *)SvPV_nolen(ST(0));
#line 469 "Interrupt.xs"
{
  	s_epipe *epp;

        Newz (0, epp, 1, s_epipe);
        XPUSHs (sv_setref_iv (sv_newmortal (), klass, PTR2IV (epp)));

        if (s_epipe_new (epp) < 0)
          croak ("Async::Interrupt::EventPipe: unable to create new event pipe");
}
#line 781 "Interrupt.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_Async__Interrupt__EventPipe_filenos)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))));
#line 482 "Interrupt.xs"
        EXTEND (SP, 2);
        PUSHs (sv_2mortal (newSViv (epp->fd [0])));
        PUSHs (sv_2mortal (newSViv (epp->fd [1])));
#line 805 "Interrupt.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_Async__Interrupt__EventPipe_fileno)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    {
	int	RETVAL;
	dXSTARG;
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))));
#line 493 "Interrupt.xs"
        RETVAL = epp->fd [ix];
#line 828 "Interrupt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

static
XS(XS_Async__Interrupt__EventPipe_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    {
	int	RETVAL;
	dXSTARG;
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))));
#line 500 "Interrupt.xs"
        RETVAL = epp->len;
#line 850 "Interrupt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

static
XS(XS_Async__Interrupt__EventPipe_signal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    {
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))));

	s_epipe_signal(epp);
    }
    XSRETURN_EMPTY;
}

static
XS(XS_Async__Interrupt__EventPipe_drain)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    {
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))));

	s_epipe_drain(epp);
    }
    XSRETURN_EMPTY;
}

static
XS(XS_Async__Interrupt__EventPipe_signal_func)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))));
#line 515 "Interrupt.xs"
        EXTEND (SP, 2);
        PUSHs (sv_2mortal (newSViv (PTR2IV (ix ? s_epipe_drain : s_epipe_signal))));
        PUSHs (sv_2mortal (newSViv (PTR2IV (epp))));
#line 911 "Interrupt.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_Async__Interrupt__EventPipe_wait)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    {
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))));

	s_epipe_wait(epp);
    }
    XSRETURN_EMPTY;
}

static
XS(XS_Async__Interrupt__EventPipe_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    {
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))));
#line 525 "Interrupt.xs"
        s_epipe_destroy (epp);
#line 949 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
#if (__GNUC__ >= 4) && defined(__ELF__)
XS(boot_Async__Interrupt) __attribute__((visibility("default")));
#else
XS(boot_Async__Interrupt); /* prototype to pass -Wmissing-prototypes */
#endif
XS(boot_Async__Interrupt)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXS("Async::Interrupt::_alloc", XS_Async__Interrupt__alloc, file);
        newXS("Async::Interrupt::signal_hysteresis", XS_Async__Interrupt_signal_hysteresis, file);
        newXS("Async::Interrupt::signal_func", XS_Async__Interrupt_signal_func, file);
        newXS("Async::Interrupt::scope_block_func", XS_Async__Interrupt_scope_block_func, file);
        newXS("Async::Interrupt::c_var", XS_Async__Interrupt_c_var, file);
        newXS("Async::Interrupt::signal", XS_Async__Interrupt_signal, file);
        newXS("Async::Interrupt::block", XS_Async__Interrupt_block, file);
        newXS("Async::Interrupt::unblock", XS_Async__Interrupt_unblock, file);
        newXS("Async::Interrupt::scope_block", XS_Async__Interrupt_scope_block, file);
        cv = newXS("Async::Interrupt::pipe_enable", XS_Async__Interrupt_pipe_enable, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Async::Interrupt::pipe_disable", XS_Async__Interrupt_pipe_enable, file);
        XSANY.any_i32 = 0 ;
        newXS("Async::Interrupt::pipe_fileno", XS_Async__Interrupt_pipe_fileno, file);
        newXS("Async::Interrupt::pipe_autodrain", XS_Async__Interrupt_pipe_autodrain, file);
        newXS("Async::Interrupt::post_fork", XS_Async__Interrupt_post_fork, file);
        newXS("Async::Interrupt::DESTROY", XS_Async__Interrupt_DESTROY, file);
        cv = newXSproto_portable("Async::Interrupt::sig2num", XS_Async__Interrupt_sig2num, file, "$");
        XSANY.any_i32 = 0 ;
        cv = newXSproto_portable("Async::Interrupt::sig2name", XS_Async__Interrupt_sig2num, file, "$");
        XSANY.any_i32 = 1 ;
        newXS("Async::Interrupt::EventPipe::new", XS_Async__Interrupt__EventPipe_new, file);
        newXS("Async::Interrupt::EventPipe::filenos", XS_Async__Interrupt__EventPipe_filenos, file);
        cv = newXS("Async::Interrupt::EventPipe::fileno_w", XS_Async__Interrupt__EventPipe_fileno, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Async::Interrupt::EventPipe::fileno_r", XS_Async__Interrupt__EventPipe_fileno, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Async::Interrupt::EventPipe::fileno", XS_Async__Interrupt__EventPipe_fileno, file);
        XSANY.any_i32 = 0 ;
        newXS("Async::Interrupt::EventPipe::type", XS_Async__Interrupt__EventPipe_type, file);
        newXS("Async::Interrupt::EventPipe::signal", XS_Async__Interrupt__EventPipe_signal, file);
        newXS("Async::Interrupt::EventPipe::drain", XS_Async__Interrupt__EventPipe_drain, file);
        cv = newXS("Async::Interrupt::EventPipe::signal_func", XS_Async__Interrupt__EventPipe_signal_func, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Async::Interrupt::EventPipe::drain_func", XS_Async__Interrupt__EventPipe_signal_func, file);
        XSANY.any_i32 = 1 ;
        newXS("Async::Interrupt::EventPipe::wait", XS_Async__Interrupt__EventPipe_wait, file);
        newXS("Async::Interrupt::EventPipe::DESTROY", XS_Async__Interrupt__EventPipe_DESTROY, file);
    }

    /* Initialisation Section */

#line 249 "Interrupt.xs"
	old_sighandler = PL_sighandlerp;
        PL_sighandlerp = async_sighandler;
        sig_pending = &PL_sig_pending;
        psig_pend   = PL_psig_pend;
        asyncs      = newAV ();
        CvNODEBUG_on (get_cv ("Async::Interrupt::scope_block", 0)); /* otherwise calling scope can be the debugger */

#line 1035 "Interrupt.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

